//
// Emacs editing mode: -*- C++ -*- 
//
//
//
// Copyright (c) 1997-2003 Marconi Communications, Inc. as an unpublished work.
//
// All rights reserved.
//
//
//
//
/*
 * modified by Scalable Networks, Inc.
 * Copyright (C) 1996 Scalable Networks, Inc.  All rights reserved.
 */

/*
 * Definitions for Abstract Syntax Notation One, ASN.1
 * As defined in ISO/IS 8824 and ISO/IS 8825
 *
 *
 */
/***********************************************************
	Copyright 1988, 1989 by Carnegie Mellon University

                      All Rights Reserved

Permission to use, copy, modify, and distribute this software and its 
documentation for any purpose and without fee is hereby granted, 
provided that the above copyright notice appear in all copies and that
both that copyright notice and this permission notice appear in 
supporting documentation, and that the name of CMU not be
used in advertising or publicity pertaining to distribution of the
software without specific, written prior permission.  

CMU DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL
CMU BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR
ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,
ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS
SOFTWARE.
******************************************************************/
#ifndef _asn1_h_
#define _asn1_h_

/* if switch cmu snmp asn1.h was already included
   do not define this stuff. Use the defs from snmp/asn1.h */
#ifndef SNMP_ASN1_H
#define MAX_OID_LEN	    64	/* max subid's in an oid */

#define ASN_UNIVERSAL	    (0x00)
#define ASN_APPLICATION     (0x40)
#define ASN_CONTEXT	    (0x80)
#define ASN_PRIVATE	    (0xC0)

#define ASN_BOOLEAN	   (unsigned char) ((0x01)|(ASN_UNIVERSAL))
#define ASN_INTEGER	   (unsigned char) ((0x02)|(ASN_UNIVERSAL))
#define ASN_BIT_STR	   (unsigned char) ((0x03)|(ASN_UNIVERSAL))
#define ASN_OCTET_STR	   (unsigned char) ((0x04)|(ASN_UNIVERSAL))
#define ASN_NULL	   (unsigned char) ((0x05)|(ASN_UNIVERSAL))
#define ASN_OBJECT_ID	   (unsigned char) ((0x06)|(ASN_UNIVERSAL))

#define ASN_SEQUENCE	    (0x10)
#define ASN_SET		    (0x11)

#define ASN_PRIMITIVE	    (0x00)
#define ASN_CONSTRUCTOR	    (0x20)

#define ASN_LONG_LEN	    (0x80)
#define ASN_EXTENSION_ID    (0x1F)
#define ASN_BIT8	    (0x80)

#define IS_CONSTRUCTOR(byte)	((byte) & ASN_CONSTRUCTOR)
#define IS_EXTENSION_ID(byte)	(((byte) & ASN_EXTENSION_ID) == ASN_EXTENSION_ID)
#endif /* SNMP_ASN1_H asn1 definitions */

//
// SNMP application primitives
//
#ifndef  _SNMP_IMPL_H
// If snmp_impl.h is already been included
// do not use these definitions.
#define INTEGER	    ASN_INTEGER
#define INTEGER32   ASN_INTEGER
#define STRING	    ASN_OCTET_STR
#define OBJID	    ASN_OBJECT_ID
#define NULLOBJ	    ASN_NULL

/* defined types (from the SMI, RFC 1157) */
#define IPADDRESS   (unsigned char) ((0x00)|(ASN_APPLICATION))
#define COUNTER	    (unsigned char) ((0x01)|(ASN_APPLICATION))
#define COUNTER32   COUNTER
#define GAUGE	    (unsigned char) ((0x02)|(ASN_APPLICATION))
#define GAUGE32     GAUGE
#define UNSIGNED32  GAUGE
#define TIMETICKS   (unsigned char) ((0x03)|(ASN_APPLICATION))
#define OPAQUE      (unsigned char) ((0x04)|(ASN_APPLICATION))
#define BITS        ASN_OCTET_STR

/* defined types (from the SMI, RFC xxxx) */
#define COUNTER64   (unsigned char) ((0x06)|(ASN_APPLICATION))
#endif /*  _SNMP_IMPL_H */


// define some snmp operations.
#ifndef GET_REQ_MSG
// if get_req_msg is already defined then use the definitions
// from the cmu snmp snmp.h file.
#define GET_REQ_MSG          (0x0)
#define GETNEXT_REQ_MSG      (0x1)
#define GET_RSP_MSG          (0x2)
#define SET_REQ_MSG          (0x3)
#define TRP_REQ_MSG          (0x4)
#define GETBULK_REQ_MSG      (0x5)
#define INFORM_REQ_MSG       (0x6)
#define TRP2_REQ_MSG         (0x7)
#define REPORT_REQ_MSG       (0x8)
#endif /* GET_REQ_MSG */

// define some snmpV2 exception codes
#define NOSUCHOBJECT    (ASN_CONTEXT | ASN_PRIMITIVE | 0x0)
#define NOSUCHINSTANCE  (ASN_CONTEXT | ASN_PRIMITIVE | 0x1)
#define ENDOFMIBVIEW    (ASN_CONTEXT | ASN_PRIMITIVE | 0x2)

#endif /* _asn1_h_ */

